package editor

import "testing"

func TestNewRow(t *testing.T) {
	str := "abcdefg"
	row := newRow(str)

	got := string(row.chars)
	want := str

	if got != want {
		t.Errorf("Row chars not equal to original string. Row: %q, String: %q", row, str)
	}
}

func TestRowSize(t *testing.T) {
	str := "abcdefg"
	row := newRow(str)

	got := row.size()
	want := 7

	if got != want {
		t.Errorf("Row size not equal to number of runes in original string")
	}
}

func TestRenderSize(t *testing.T) {
	str := "\tabcdefg"
	row := newRow(str)
	row.update()

	got := row.rSize()
	want := 11

	if got != want {
		t.Errorf("Row rsize not equal to number of runes in original string")
	}
}
